// 002 u_file_byte_frequency
// 30 jun 2009

// -- (C) John COLIBRI 2009
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_file_byte_frequency;
  Interface
    Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
        , StdCtrls, FileCtrl, ExtCtrls, ComCtrls
        ;

    type TForm1=
             class(TForm)
                 command_panel: tPanel;
                 exit_panel: tPanel;
                 exit_: tButton;
                 clear_: tButton;
                 help_: tButton;
                 dir_file_panel: tPanel;
                 favorites_panel: tPanel;
                 DirectoryListbox1: tDirectoryListbox;
                 dir_file_splitter: tSplitter;
                 FileListbox1: tFileListbox;
                 bottom_panel: tPanel;
                 all_dir_: tButton;
    dir_recursive_: TButton;
                 left_splitter: tSplitter;
                 display_pagecontrol: tPageControl;
                 display_tabsheet: tTabSheet;
                 Memo1: tMemo;
                 result__tabsheet: tTabSheet;
                 result__memo_: tMemo;
    reset_byte_frequency_: TButton;
    display_frequencies_: TButton;
    check_return_linefeed_: TCheckBox;
    mute_: TCheckBox;
                 Procedure Form1Create(Sender: tObject);
                 Procedure Form1Close(Sender: TObject; var Action: TCloseAction);
                 Procedure exit_Click(Sender: tObject);
                 Procedure clear_Click(Sender: tObject);
                 Procedure help_Click(Sender: tObject);
                 Procedure DirectoryListbox1Change(Sender: tObject);
                 Procedure FileListbox1Click(Sender: tObject);
                 Procedure all_dir_Click(Sender: tObject);
                 Procedure dir_recursive_Click(Sender: tObject);
    procedure reset_byte_frequency_Click(Sender: TObject);
    procedure display_frequencies_Click(Sender: TObject);
               private
                 procedure handle_favorite_path_click(p_path, p_extension: String);
               public
             end; // TForm1

    var Form1: tForm1= Nil;

  implementation
    Uses u_c_display, u_c_log
        , u_help
        , u_types_constants, u_characters
        , u_c_favorite_path_list
        , u_exe
        , u_file, u_dir
        , u_c_ini_file
        , u_handle_files_in_dirs

        , u_c_byte_buffer
      ;

    {$R *.DFM}

   
    //.copy_file ..\exe\help\file_byte_frequency_help.txt

    Const k_xxx_path=                'c:\prog\xxx\';
          k_xxx_file_name=           'pascal.pas';
          k_xxx_path_ini_key=        'ini_xxx_path';
          k_xxx_file_name_ini_key=   'ini_xxx_file_name';

    Var g_path:          String= k_xxx_path;
        g_file_name:     String= k_xxx_file_name;
        g_c_ini_file:    c_ini_file= Nil;
        g_file_count:    Integer= 0;
        g_c_favorite_path_list: c_favorite_path_list= Nil;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    var g_byte_frequency: array[0..255] of Integer;

    procedure TForm1.reset_byte_frequency_Click(Sender: TObject);
      begin
        FillChar(g_byte_frequency, SizeOf(g_byte_frequency), 0);
      end; // initialize_frequency

    procedure compute_frequency_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      var l_index: Integer;
          l_return_linefeed_file_name: String;
      begin
        if not Form1.mute_.Checked
          then display(Copy(p_path, Length(g_path)+ 1, Length(p_path)+ 1- Length(g_path)));
        Inc(g_file_count);

        l_return_linefeed_file_name:= p_file_name;

        with c_byte_buffer.create_byte_buffer('', 10) do
        begin
          load_from_file(p_path+ p_file_name);
          if not Form1.mute_.Checked
            then display(Format('  [%9d] ', [m_write_index])+ p_file_name);

          // -- compute the frequencies
          for l_index:= 0 to m_write_index- 1 do
          begin
            if Form1.check_return_linefeed_.Checked
              then
                if (m_oa_byte_buffer[l_index]= Ord(k_return))
                  then begin
                      if (l_index+ 1< m_buffer_size) and (m_oa_byte_buffer[l_index+ 1]<> Ord(k_line_feed))
                        then begin
                            if l_return_linefeed_file_name<> ''
                              then begin
                                  display(l_return_linefeed_file_name);
                                  l_return_linefeed_file_name:= '';
                                end;
                            display(Format('  no return+linefeed_at %9d', [l_index]));
                          end;
                    end;
            Inc(g_byte_frequency[m_oa_byte_buffer[l_index]]);
          end; // for l_index

          Free;
        end; // with c_byte_buffer
      end; // compute_frequency_call_back

    // -- events

    procedure TForm1.Form1Create(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_xxx_path_ini_key, k_xxx_path);
          g_file_name:= f_initialize_parameter(k_xxx_file_name_ini_key, k_xxx_file_name);
        end; // with g_c_ini_file
        display_path_and_file;

        g_c_favorite_path_list:= c_favorite_path_list.create_favorite_path_list(
            f_exe_path+ 'favorites\'+ f_exe_pure_project_name+ '_favorites.txt',
            favorites_panel, handle_favorite_path_click);

        set_directory_listbox_directory(DirectoryListBox1, g_path);
        with FileListBox1, Items do
          ItemIndex:= IndexOf(g_file_name);

        reset_byte_frequency_Click(Nil);
      end; // Form1Create

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.Form1Close(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // Form1Close

    // -- call handler

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_xxx_path_ini_key, g_path);
      end; // DirectoryListBox1Change

    procedure TForm1.FileListBox1Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      begin
        with FileListbox1 do
          g_file_name:= Items[ItemIndex];
        g_c_ini_file.set_parameter(k_xxx_file_name_ini_key, g_file_name);

        g_file_count:= 0;
        compute_frequency_call_back(0, g_path, g_file_name, Nil);
        g_c_ini_file.save_to_default_file;
      end; // FileListBox1Click

    procedure handle_the_files(p_dir_handling_types: t_dir_handling_types);
      var l_extension: String;
          l_path: String;
      begin
        l_path:= f_without_ending_slash(g_path);

        l_extension:= Form1.FileListBox1.Mask;
        Delete(l_extension, 1, 1);
        l_extension:= UpperCase(l_extension);

        display_line;
        display('handle_non_rec of '+ l_path+ ' '+ l_extension);
        display_line;
        g_file_count:= 0;

        handle_all_files_recursive(1, l_path, l_extension,
            p_dir_handling_types, compute_frequency_call_back, Nil);

        display_line;
        display(Format('FINISHED %3d files', [g_file_count]));
      end; // handle_the_files

    procedure TForm1.all_dir_Click(Sender: TObject);
      // -- all the file of this folder (non rec)
      begin
        handle_the_files([e_dir_handle_file]);
      end; // btn_all_dirClick

    procedure TForm1.dir_recursive_Click(Sender: TObject);
      begin
        handle_the_files([e_dir_handle_file, e_dir_recursive]);
      end; // dir_rec_Click

    procedure tForm1.handle_favorite_path_click(p_path, p_extension: String);
      begin
        set_directory_listbox_directory(DirectoryListbox1, p_path);
      end; // handle_favorite_path_click

    procedure TForm1.help_Click(Sender: TObject);
      begin
        display_help;
      end; // help_Click

    procedure TForm1.display_frequencies_Click(Sender: TObject);
      var l_index: Integer;
          l_character: Char;
      begin
        // -- display only the > 0 values
        display(Format('frequencies of %-5s files, file_count=%3d in ',
            [FileListBox1.Mask, g_file_count]) + g_path);
        for l_index:= 0 to 255 do
          if g_byte_frequency[l_index]> 0
            then begin
                if l_index in [0..32]
                  then l_character:= ' '
                  else l_character:= chr(l_index);
                display(Format('%3d %1s %7d',
                    [l_index, l_character, g_byte_frequency[l_index]]));
              end;
      end; // display_frequencies_Click

end. // byte_frequency

